---
title: NotificationEvent
slug: Web/API/NotificationEvent
tags:
  - API
  - Experimental
  - Interface
  - NotificationEvent
  - Notifications
  - Reference
  - Service Workers
  - ServiceWorker
---
<p>{{APIRef("Web Notifications")}}</p>

<p>The parameter passed into the {{domxref("ServiceWorkerGlobalScope.onnotificationclick", "onnotificationclick")}} handler, the <code>NotificationEvent</code> interface represents a notification click event that is dispatched on the {{domxref("ServiceWorkerGlobalScope")}} of a {{domxref("ServiceWorker")}}.</p>

<p>This interface inherits from the {{domxref("ExtendableEvent")}} interface.</p>

<h2 id="Constructor">Constructor</h2>

<dl>
 <dt>{{domxref("NotificationEvent.NotificationEvent","NotificationEvent()")}}</dt>
 <dd>Creates a new <code>NotificationEvent</code> object.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<p><em>Inherits properties from its ancestor, {{domxref("Event")}}</em>.</p>

<dl>
 <dt>{{domxref("NotificationEvent.notification")}} {{readonlyInline}}</dt>
 <dd>Returns a {{domxref("Notification")}} object representing the notification that was clicked to fire the event.</dd>
 <dt>{{domxref("NotificationEvent.action")}} {{readonlyinline}}</dt>
 <dd>Returns the string ID of the notification button the user clicked. This value returns an empty string if the user clicked the notification somewhere other than an action button, or the notification does not have a button.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<p><em>Inherits methods from its parent, {{domxref("ExtendableEvent")}}</em>.</p>

<dl>
 <dt>{{domxref("ExtendableEvent.waitUntil", "ExtendableEvent.waitUntil()")}}</dt>
 <dd>
 <p>Extends the lifetime of the event. Tells the browser that work is ongoing.</p>
 </dd>
</dl>

<h2 id="Example">Example</h2>

<pre class="brush: js notranslate">self.addEventListener('notificationclick', function(event) {
  console.log('On notification click: ', event.notification.tag);
  event.notification.close();

  // This looks to see if the current is already open and
  // focuses if it is
  event.waitUntil(clients.matchAll({
    type: "window"
  }).then(function(clientList) {
    for (var i = 0; i &lt; clientList.length; i++) {
      var client = clientList[i];
      if (client.url == '/' &amp;&amp; 'focus' in client)
        return client.focus();
    }
    if (clients.openWindow)
      return clients.openWindow('/');
  }));
});
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('Web Notifications','#notificationevent','NotificationEvent')}}</td>
   <td>{{Spec2('Web Notifications')}}</td>
   <td>Living standard.</td>
  </tr>
 </tbody>
</table>

<div class="note">
<p><strong>Note</strong>: This interface is specified in the <a href="/en-US/docs/Web/API/Notifications_API">Notifications API</a>, but accessed through {{domxref("ServiceWorkerGlobalScope")}}.</p>
</div>

<h2 id="Browser_Compatibility">Browser Compatibility</h2>

<div>

<p>{{Compat("api.NotificationEvent")}}</p>
</div>
